/*
Changelog
0.1 - nie dzialal plugin xd
0.2 - wkoncu zadzialal skrypt
0.3 - zmieniona metoda nagradzania z ifa na casy
	- wreczanie nagrod po zabiciu a nie w nowej rundzie
	- funkcja wyzerowujaca
	- kara za TK
0.4 - Dodanie nalotu
0.41 - Ogolne poprawki nalotu
0.45 - Scout 1 ammo
	- laser przy scoucie na cvar
0.5 - Dodanie radaru
0.6 - Poprawa bledu z radarem
	- drobne poprawki
	- cvar na wyzerowanie
	- zmiana sposobu zerowania
*/

#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>
#include <cstrike>
#include <fun>
#include <engine>
#include <fakemeta>
#include <fakemeta_util>

#define PLUGIN "KillStrike"
#define VERSION "0.5"
#define AUTHOR "CeLeS"

#define MAXBOMBS 30 // Ilosc Bomb
#define BETWEENTIME 2 
#define RADIUS 400 // Promien Bombardowania

new const sound_radar[] = "radar.wav";
new const sound_siren[] = "ambience/siren.wav";
new const sound_jet[] = "ambience/jetflyby1.wav";
new const rakieta[] = "models/rpgrocket.mdl";

new rgb[3];

new g_msgHostageAdd, g_msgHostageDel, g_maxplayers;

new inuse = 0;
new donebombs = MAXBOMBS;
new bombs[MAXBOMBS];
new Float:timers[MAXBOMBS];
new SpriteExplosion, SpriteLaser; 

new licznik_zabic[33];
new name[32];
//new ilosc_hp = 100;
//new ilosc_arm = 100;
new nalot[33], radar[33];

new ks_laser, ks_wyzeruj;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	register_forward(FM_CmdStart, "strzal");
	register_event("DeathMsg", "death", "a");
	register_logevent("wyzeruj", 2, "1=Round_End");
	
	ks_laser = register_cvar("ks_laser", "1");
	ks_wyzeruj = register_cvar("ks_wyzeruj", "1");

	g_msgHostageAdd = get_user_msgid("HostagePos");
	g_msgHostageDel = get_user_msgid("HostageK");
	
	g_maxplayers = get_maxplayers();
	for (new i = 1; i<=g_maxplayers;i++) radar[i] = false;	
	set_task (2.0,"radar_scan",_,_,_,"b");
}

public plugin_precache() 
{ 
	SpriteExplosion = precache_model("sprites/dexplo.spr");
	SpriteLaser = precache_model("sprites/white.spr");
	precache_sound(sound_radar);
	precache_sound(sound_siren);
	precache_sound(sound_jet);
	precache_model(rakieta);
} 

public wyzeruj()
{
	new id;
	for (id=1; id<=g_maxplayers; id++)
	{
		if(!is_user_alive(id))
		{
			licznik_zabic[id] = 0;
			set_hudmessage(255, 255, 255, -1.0, 0.33, 0, 5.0, 5.0);
			show_hudmessage(id, "KILLSTRIKE zostal WYZEROWANY %s", id);
			nalot[id] = false;
			radar[id] = false;
		}
		if(get_pcvar_num(ks_wyzeruj) !=1)
				{
			licznik_zabic[id] = 0;
			set_hudmessage(255, 255, 255, -1.0, 0.33, 0, 5.0, 5.0);
			show_hudmessage(id, "KILLSTRIKE zostal WYZEROWANY %s", id);
			nalot[id] = false;
			radar[id] = false;
		}
	}
}

//Nagrody za KillStrike

public nagroda(id)
	if (is_user_alive(id))
	{	
		//new hp = get_user_health(id);
		//new arm = get_user_armor(id);
		get_user_name(id,name,31);
		if(licznik_zabic[id] > 0)
			switch(licznik_zabic[id])
			{
				case 3:
				{
					radar[id] = true;
					set_hudmessage(255, 255, 255, -1.0, 0.33, 0, 5.0, 5.0);
					show_hudmessage(0, "%s dostal RADAR za KILLSTRIKE x %i !", name, licznik_zabic[id]);
					client_print(id, print_chat, "[KillStrike] Czerwone punkty na radarze to wszyscy zywi gracze");
				}
				case 5:
				{
					nalot[id] = true;
					new ent = give_item(id, "weapon_scout");
					cs_set_user_bpammo(id, CSW_SCOUT, 0);
					if(pev_valid(ent))
						cs_set_weapon_ammo(ent, 1);
					set_hudmessage(255, 255, 255, -1.0, 0.33, 0, 5.0, 5.0);
					show_hudmessage(0, "%s dostal NALOT za KILLSTRIKE x %i !", name, licznik_zabic[id]);
					client_print(id, print_chat, "[KillStrike] Wskarz miejsce nalotu strzelajac ze SCOUTA");
				}
				/*
				case ilosc_zabic:
				{
					set_user_health(id, hp+ilosc_hp);
					set_user_armor(id, arm+ilosc_arm);
					give_item(id, "weapon_bron);
					set_hudmessage(255, 255, 255, -1.0, 0.33, 0, 5.0, 5.0);
					show_hudmessage(0, "%s dostal xxx za KILLSTRIKE x %i !", name, licznik_zabic[id]);
				}
				*/	
			}
	}
	
//Sprawdzenie strzalu do nalotu

public strzal(id)
{ 
	if(get_user_weapon(id) == CSW_SCOUT && (get_user_button(id) & IN_ATTACK) && nalot[id])
	{
		set_task(0.1, "CMD_airraid", id);
		set_hudmessage(255, 255, 255, -1.0, 0.33, 0, 5.0, 5.0);
		show_hudmessage(0, "WSPARCIE NADLATUJE!", id);
	}
	return PLUGIN_CONTINUE;
}

public death()
{
	new killer = read_data(1);
	new victim = read_data(2);
	if(!is_user_alive(killer) || !is_user_connected(killer))
		return PLUGIN_CONTINUE;
	if(get_user_team(victim) != get_user_team(killer))
	{
		licznik_zabic[killer] ++ ;
		set_hudmessage(255, 255, 255, 0.50, 0.33, 1, 7.0, 1.0);
		show_hudmessage(killer, "Twoj KILLSTRIKE to x%i", licznik_zabic[killer]);
		set_task(0.3, "nagroda", killer);
	}
	else
	{
		licznik_zabic[killer] -- ;
		set_hudmessage(255, 255, 255, 0.50, 0.33, 1, 7.0, 1.0);
		show_hudmessage(killer, "Straciles 1 KILLSTRIKE za TEAM KILL");
	}
	return PLUGIN_CONTINUE;
}

//Nalot

public CMD_airraid(id, level, cid) 
{ 
    new k;
     
    if (nalot[id]){

    if (inuse == 1 && donebombs != MAXBOMBS) 
    { 
        client_print(id, print_chat, "You must wait longer before issuing another air strike");
        return PLUGIN_HANDLED;
    } 
	 
    inuse = 1;
     
    emit_sound(id,CHAN_AUTO, sound_siren, 1.0, ATTN_NORM, 0, PITCH_NORM);
     
    new Float:ftime;
    ftime = float(BETWEENTIME);
     
    set_task(ftime, "ACT_resetraid");
    set_task(3.0, "CRT_bomb", id);
    set_task(5.0, "ACT_stopsound");
    set_task(3.0, "ACT_flybysound", id);
     
    for (k = 0; k<MAXBOMBS; k++) 
    { 
        timers[k] = random_float(1.0,2.0); 
    }
     
    nalot[id] = false;
     
    return PLUGIN_HANDLED;
	}
    return PLUGIN_CONTINUE;
} 

//Zasieg + DMG + Wielkosc Sprita

public ACT_explodebomb(posistion) 
{ 
    new location[3]; 
    new Float:Vec[3]; 
    IVecFVec(location, Vec); 
    entity_get_vector(bombs[posistion], EV_VEC_origin, Vec); 
    FVecIVec(Vec, location); 
    location[2] = location[2] + 20; 
    CRT_explosion(location, SpriteExplosion, 60, 10, 0); 
    REM_bomb(posistion); 
     
    new players[32]; 
    new playercount; 
	  
    get_players(players,playercount,"a"); 
     
    for (new m=0; m<playercount; m++) 
    { 
        new playerlocation[3]; 
        new resultdistance; 
         
        get_user_origin(players[m], playerlocation); 
         
        resultdistance = get_distance(playerlocation,location); 
         
        if(resultdistance < 250) 
        {           
			fakedamage(players[m],"Air Raid",1000.0,DMG_BURN); 
        } 
    } 
} 

public REM_bomb(posistion) 
{ 
    remove_entity(bombs[posistion]); 
    bombs[posistion] = 0; 
} 

//Pozycja zrzutu

public CRT_bomb(id) 
{ 
    new location[3]; 
    new randomlocation[3]; 
    new endrandomlocation[3]; 
    new randomx; 
    new randomy; 
     
    get_user_origin(id, location, 3); 
     
    location[2] = location[2] + 300; 
     
    donebombs = 0; 
     
    for (new i=0; i<MAXBOMBS; i++) 
    { 
        randomx = random_num(-RADIUS,RADIUS); 
        randomy = random_num(-RADIUS,RADIUS); 
         
        randomlocation[0] = location[0]+1*randomx; 
        randomlocation[1] = location[1]+1*randomy; 
        randomlocation[2] = location[2]; 
         
        new Float:LocVec[3]; 
        IVecFVec(randomlocation, LocVec); 
         
        endrandomlocation[0] = randomlocation[0]; 
        endrandomlocation[1] = randomlocation[1];
        endrandomlocation[2] = randomlocation[2] - 5; 
         
        new Float:EndVec[3]; 
        IVecFVec(endrandomlocation, EndVec); 
         
        new Float:VeloVec[3]; 
        VeloVec[0] = (EndVec[0] - LocVec[0])*1+1; 
        VeloVec[1] = (EndVec[1] - LocVec[1])*1+1; 
        VeloVec[2] = (EndVec[2] - LocVec[2])*1+1; 
         
         
        bombs[i] = create_entity("info_target"); 
        if (!bombs[i]) 
            return PLUGIN_HANDLED; 
         
        entity_set_string(bombs[i], EV_SZ_classname, "Bomb");  
        entity_set_edict(bombs[i], EV_ENT_owner, id); 
        entity_set_int(bombs[i], EV_INT_solid, 1); 
        entity_set_int(bombs[i], EV_INT_movetype, 6); 
        entity_set_model(bombs[i], rakieta);    
        entity_set_origin(bombs[i], LocVec); 
        entity_set_vector(bombs[i], EV_VEC_velocity, VeloVec);           
        DispatchSpawn(bombs[i]); 
    } 
     
    for (new k = 0; k<MAXBOMBS; k++) 
    { 
        set_task(timers[k], "ACT_explodebomb", k); 
    } 
     
    return PLUGIN_CONTINUE; 
} 

public ACT_resetraid() 
{ 
    inuse = 0; 
    return PLUGIN_CONTINUE; 
} 

public ACT_stopsound() 
{ 
    client_cmd(0,"stopsound"); 
    return PLUGIN_CONTINUE; 
} 

public ACT_flybysound(id) 
{ 
    emit_sound(id,CHAN_AUTO, sound_jet, 1.0, ATTN_NORM, 0, PITCH_NORM); 
    return PLUGIN_CONTINUE; 
} 

public CRT_explosion(location[3], spritename, scale, framerate, flags) 
{ 
    message_begin( MSG_BROADCAST, SVC_TEMPENTITY); 
    write_byte(3);
    write_coord(location[0]); 
    write_coord(location[1]); 
    write_coord(location[2]); 
    write_short(spritename); 
    write_byte(scale); 
    write_byte(framerate); 
    write_byte(flags); 
    message_end(); 
} 

//Laser

public client_PreThink(id)
{
	if(!is_user_alive(id) || get_pcvar_num(ks_laser)!=1) return PLUGIN_HANDLED;
	
	if(get_user_weapon(id) != CSW_SCOUT) return PLUGIN_HANDLED;
	
	new e[3];
	
	get_user_origin(id, e, 3);
	
	rgb[0] = 255;
	rgb[1] = 0;
	rgb[2] = 0;
	
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY);
	
	write_byte (TE_BEAMENTPOINT);
	write_short(id | 0x1000);
	write_coord (e[0]);
	write_coord (e[1]);
	write_coord (e[2]);
	
	write_short(SpriteLaser);
	write_byte (0);
	write_byte (10);
	write_byte (1);
	write_byte (5);
	write_byte (0);
	
	write_byte (rgb[0]);
	write_byte (rgb[1]);
	write_byte (rgb[2]);
	
	write_byte (255);
	write_byte (10);
	message_end();
	
	return PLUGIN_HANDLED;
}

//Radar

public radar_scan()
{
	new PlayerCoords[3];
	new id;
	new Players[32];
	new i;
	new playerCount = 0;

	for (id=1; id<=g_maxplayers; id++)
	{
		if((!is_user_alive(id))||(!radar[id])) continue;
		
		if(get_players(Players, playerCount, "a") &&is_user_alive(id))
		{
		playerCount++; 
		}
		
		for (i=1;i<=playerCount;i++)
		{	
			get_user_origin(i, PlayerCoords)
		
			message_begin(MSG_ONE_UNRELIABLE, g_msgHostageAdd, {0,0,0}, id)
			write_byte(id)
			write_byte(i)		
			write_coord(PlayerCoords[0])
			write_coord(PlayerCoords[1])
			write_coord(PlayerCoords[2])
			message_end()
		
			message_begin(MSG_ONE_UNRELIABLE, g_msgHostageDel, {0,0,0}, id)
			write_byte(i)
			message_end()
		}
		emit_sound(id, CHAN_ITEM, sound_radar, 1.0, ATTN_NORM, 0, PITCH_NORM);
	}
}
